{
  Delphi 4.0 exception test program
}

{$APPTYPE CONSOLE}

PROGRAM Except2;

uses  SysUtils, Crt, Ex2;

const saveExitProc: pointer = NIL;

{*********************************************************}
procedure AddExitProc (myExitProc: tProcedure);
begin
  saveExitProc := system.ExitProc;
  system.ExitProc := addr(myExitProc);
end;

(*******************************************************************)
function ExceptionErrorString (ExceptObj: TObject): string;

var   ExceptStr: string;
      Size: Integer;
begin
  system.errorAddr := ExceptAddr;
  size := ExceptionErrorMessage(ExceptObj, ExceptAddr, @ExceptStr[1], 255);
  ExceptStr[0] := char(size);
  ExceptionErrorString := ExceptStr;
end;
(*******************************************************************)
procedure MainExitProc; FAR;
begin
  system.ExitProc := saveExitProc;     {restore old exit proc}
  saveExitProc := nil;                 {delete saved exit proc}
  system.errorAddr := ExceptAddr;
  writeln ('Runtime Error ',system.exitCode
  , ': '   + RuntimeErrorMsg(system.exitCode)
  , ' at ' + IntToHex(longint(system.errorAddr),8));

  writeln ('--- EXCEPTION MESSAGE ---'#13#10
          ,ExceptionErrorString (ExceptObject),#13#10
          ,'-------------------------');

  write ('press return to quit ... ');
  Readln;
end;

(*******************************************************************)
procedure ExitProgram (rtError: byte; errorAddr: pointer);
begin
  system.errorAddr := errorAddr;
  system.exitCode := rtError;
  RunError (rtError);
end;

{*********************************************************}
begin
  AddExitProc (MainExitProc);
  writeln ('EXCEPT2: Delphi-4 Exception Test'#13#10);
  try
    StartTest;
  except
    on E:EInOutError     do ExitProgram (E.errorCode, ExceptAddr);
    on EDivByZero        do ExitProgram (200, ExceptAddr);
    on ERangeError       do ExitProgram (201, ExceptAddr);
    on EStackOverflow    do ExitProgram (202, ExceptAddr);
    on EOutOfMemory      do ExitProgram (203, ExceptAddr);
    on EInvalidPointer   do ExitProgram (204, ExceptAddr);
    on EOverflow         do ExitProgram (205, ExceptAddr);
    on EUnderflow        do ExitProgram (206, ExceptAddr);
    on EInvalidOp        do ExitProgram (207, ExceptAddr);
    on EZeroDivide       do ExitProgram (208, ExceptAddr);
    on EAbstractError    do ExitProgram (210, ExceptAddr);
    on EIntOverflow      do ExitProgram (215, ExceptAddr);
    on EAccessViolation  do ExitProgram (216, ExceptAddr);
    on EControlC         do ExitProgram (217, ExceptAddr);
    on EPrivilege        do ExitProgram (218, ExceptAddr);
    on EInvalidCast      do ExitProgram (219, ExceptAddr);
    on EVariantError     do ExitProgram (220, ExceptAddr);
    else                    ExitProgram (230, ExceptAddr);
  end;
  writeln ('EXCEPT2: program end');
end.

