{
 Test Unit to cause different runtime errors
 useable for Delphi 4.0 and Borland Pascal 7.0 
}
{$R+,Q+,I-}

UNIT ex2;

INTERFACE

procedure StartTest;
function RuntimeErrorMsg (errorCode: integer): string;

IMPLEMENTATION

uses  Crt;

type  float = extended;
      bptr = ^byte;

{*********************************************************}
function RuntimeErrorMsg (errorCode: integer): string;

var   eStr: string;

begin
  str (ErrorCode:4, eStr);
  case errorCode of
        0..99:  eStr := 'dos error' + eStr;
      100..149: eStr := 'file error' + eStr;
      150..199: eStr := 'critical error' + eStr;
      200..255: eStr := 'fatal error' + eStr;
      else      eStr := 'unknown error' + eStr;
  end;
  case errorCode of
        0:      eStr := '';
      {--- fatal errors ---}                          {--Delphi--}
      200:      eStr := 'division by zero';           {EDivByZero}
      201:      eStr := 'out of range';               {ERangeError}
      202:      eStr := 'stack overflow';             {EStackOverflow}
      203:      eStr := 'heap overflow';              {EOutOfMemory}
      204:      eStr := 'inv. pointer operation';     {EInvalidPointer}
      205:      eStr := 'float overflow';             {EOverflow}
      206:      eStr := 'float underflow';            {EUnderflow}
      207:      eStr := 'inv. float operation';       {EInvalidOp}
      208:      eStr := 'float division by zero';     {EZeroDivide}
      210:      eStr := 'object not initialized';     {EAbstractError}
      211:      eStr := 'call to abstract method';
      215:      eStr := 'integer overflow';           {EIntOverflow}
      216:      eStr := 'access violation';           {EAccessViolation}
      {Delphi}
      217:      eStr := 'Control-C';                  {EControlC}
      218:      eStr := 'privileged instruction';     {EPrivilege}
      219:      eStr := 'invalid typecast';           {EInvalidCast}
      220:      eStr := 'invalid variant typecast';   {EVariantError}
      227:      eStr := 'assertion failed';           {EAssertionError}
      230:      eStr := 'unknown exception';
  end;
  RuntimeErrorMsg := eStr;
end;
(*******************************************************************)
procedure ExitProgram (exitCode: byte; errorAddr: pointer);
begin
  system.errorAddr := errorAddr;
  RunError (exitCode);
end;

{*********************************************************}
function DivInt (i1,i2: integer): integer;
begin
  DivInt := i1 div i2;
end;

{*********************************************************}
function MultInt (i1,i2: longint): integer;
begin
  MultInt := i1 * i2;
end;

{*********************************************************}
function DivFloat (f1,f2: float): float;
begin
  DivFloat := f1 / f2;
end;

{*********************************************************}
function MultFloat (f1,f2: float): float;
begin
  MultFloat := f1 * f2;
end;

{*********************************************************}
function RangeAccess (index: integer): byte;
var arr: array[0..1] of byte;
begin
  RangeAccess := arr[index];
end;

{*********************************************************}
{$I+}
function FileReadAccess (filename: string): byte;
var f: file;   ioerror: integer;
begin
  assign (f,filename);
  reset(f);
  close (f);
  ioerror := IOResult;
  FileReadAccess := ioerror;
end;
{*********************************************************}
function FileWriteAccess (filename: string): byte;
var f: file;   ioerror: integer;
begin
  assign (f,filename);
  rewrite(f);
  close (f);
  ioerror := IOResult;
  FileWriteAccess := ioerror;
end;

{*********************************************************}
procedure StackOverflow (s: string);
begin
  StackOverflow (s);
end;

{*********************************************************}
function InvalidPointer: byte;
var p: bptr;
  procedure xxx;
  begin
    GetMem (p,111);
    FreeMem (p,111);
  end;

begin
  xxx;
  InvalidPointer := p^;
end;

{*********************************************************}
function GetByte (p: bptr): byte;
begin
  GetByte := p^;
end;

{*********************************************************}
procedure Press_Ctrl_C;
begin
  write ('press Ctrl-C to abort ');
  repeat until false;
end;

{*********************************************************}
procedure StartTest;

const nilPointer: pointer = nil;

var   cb: char;

begin
  writeln (' 0 integer division by zero');
  writeln (' 1 integer overflow');
  writeln (' 2 float division by zero');
  writeln (' 3 float overflow');
  writeln (' 4 range error');
  writeln (' 5 file read error');
  writeln (' 6 file write error');
  writeln (' 8 invalid pointer operation');
  writeln (' 9 read nil pointer');
  writeln (' c Ctrl-C');
  writeln (' s stack overflow');
  cb := ReadKey;
  writeln (' ',cb);

  case cb of
    '0': DivInt (222, 0);
    '1': MultInt (100000, 200000);
    '2': DivFloat (333.3, 0);
    '3': MultFloat (1.0E38, 1E38);
    '4': RangeAccess (1234);
    '5': FileReadAccess ('xxx.xxx');
    '6': FileWriteAccess ('X:\xxx\xxx.xxx');
    '8': InvalidPointer;
    '9': GetByte (nilPointer);
    'c': Press_Ctrl_c;
    's': StackOverflow('???');
  end;
  writeln ('StartTest end');
end;

end.

